def callShout(greet) {
  try {
    println greet.shout()
  } catch(Exception ex) {
    println ex
  }
}

def greet = 'hello'

callShout(greet)

println '-------------'
greet.metaClass.shout = { -> toUpperCase() }

callShout(greet)

/*
Without any support from the JVM and the JIT compiler, this would be
a lot of code that can't be optimized at the bytecode level. Result,
large byte code, bigger jars, poor performance.

It would be great to enjoy the dynamic nature, metaprogramming, without losing performance
and having other negative consequences.
*/